#ifndef R2C2_NET_PACKETS_H_
#define R2C2_NET_PACKETS_H_

#include <string>

namespace R2C2 {

struct DriverStatePacket
{
	char power;
	char halt;
};

struct EmergencyPacket
{
	std::string message;
};

struct TrainInfoPacket
{
	unsigned address;
	std::string loco_type;
	std::string name;
};

struct TrainControlPacket
{
	unsigned address;
	std::string control;
	float value;
};

struct TrainFunctionPacket
{
	unsigned address;
	unsigned functions;
};

struct TrainStatusPacket
{
	unsigned address;
	std::string status;
};

struct RouteInfoPacket
{
	std::string name;
};

struct TrainRoutePacket
{
	unsigned address;
	std::string route;
};

struct ErrorPacket
{
	std::string message;
};

} // namespace R2C2

#endif
