#ifndef TRAINPANEL_H_
#define TRAINPANEL_H_

#include <gtkmm/checkbutton.h>
#include <gtkmm/combobox.h>
#include <gtkmm/expander.h>
#include <gtkmm/label.h>
#include <gtkmm/scale.h>
#include "network/client.h"
#include "network/train.h"

class Remote;

class TrainPanel: public Gtk::Expander
{
private:
	struct RouteRecord: public Gtk::TreeModelColumnRecord
	{
		Gtk::TreeModelColumn<Glib::ustring> name;

		RouteRecord();
	};

	Remote &remote;
	R2C2::Client &client;
	R2C2::NetTrain &train;
	Gtk::Scale *scl_speed;
	Gtk::Label *lbl_status;
	Gtk::CheckButton *chk_reverse;
	RouteRecord route_columns;
	Gtk::ComboBox *cmb_route;
	std::map<unsigned, Gtk::CheckButton *> chk_funcs;

public:
	TrainPanel(Remote &, R2C2::Client &, R2C2::NetTrain &);
private:
	void name_changed(const std::string &);
	void status_changed(const std::string &);
	void control_changed(const std::string &, float);
	void function_changed(unsigned, bool);
	void route_changed(const std::string &);
	void ui_speed_changed();
	void ui_reverse_changed();
	void ui_function_changed(unsigned);
	void ui_route_changed();
};

#endif
